{library_calls/log_hlp.i}

run log-it (input "input_output_double_paramter_into_int64_is_junk start").

{library_calls/libname.i}

def var res as int64.
def var dat as dec.
def var dat2 as dec.
def var i as int.
def var idx as int.
def var sz as int.
def var ptr as memptr.
def var comps as memptr.
def var d-input as dec extent.

run dvalues_size (output sz).
run init_dvalues.

set-size(ptr) = 8.
set-size(comps) = sz * 8.

run copy_dvalues (input-output comps).

extent(d-input) = sz.

/* convert the memory buffer into a decimal array, but reverse the order of the values */
do i = sz to 1 by -1:
   idx = (sz - i) + 1.
   d-input[idx] = get-double(comps, ((i - 1) * 8) + 1).
end.

/* the data will be copied as a 64-bit binary floating point value into the int64 var, but it will */
/* not be an integer that makes sense; we need to morph it back into a double to get it to "work" */
do i = 1 to sz:
   
   /* pass a value (from the reversed array of decimals copied out of the DLL) */
   /* first must coerce the bitfield into an int64 */
   put-double(ptr, 1) = d-input[i]. 
   res = get-int64(ptr, 1).
   
   run input_output_double_cdecl (input-output res).

   /* turn the junk into the proper number */
   put-int64(ptr, 1) = res.
   dat = get-double(ptr, 1).
   
   idx = ((i - 1) * 8) + 1.
   dat2 = get-double(comps, idx).
   
   if dat ne dat2 then message "Unexpected output value" dat "(index" i "; expected " dat2 ") while reading int64 from input_output_double_cdecl().".
end.

set-size(ptr) = 0.

procedure input_output_double_cdecl external "{&libname}":
   def input-output parameter dd as int64.
end.

{library_calls/input_output/input_output_parameter_end.i}

run log-it (input "input_output_double_paramter_into_int64_is_junk end").
