{library_calls/log_hlp.i}

run log-it (input "input_output_parameter_unknown_value start").

{library_calls/libname.i}

def var num as int init ?.
def var num64 as int init ?.
def var dnum as dec init ?.
def var txt as char init ?.
def var ltxt as longchar init ?.
def var ptr as memptr.
def var uninitialized-ptr as memptr.

def var blk as memptr.
def var addr as int64.

set-size(blk) = 16.
addr = get-pointer-value(blk).
run set_memory_buffer (addr, 16).

/* integer/int64/float/double cases cause error (this is different from output parameters): */
/* A variable or array element passed as an INPUT or INPUT-OUTPUT parameter to a DLL cannot contain the Unknown value. (12272) */

/* strangely, in all these 12272 situations, NO-ERROR only suppresses the message here (and records the error) */
/* BUT the error is still raised! */

c1:
do on error undo, leave c1:
   run input_output_uint8_cdecl (input-output num) no-error.
   message "Does not reach here c1.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'byte into input-output integer' test but found" num.

run reset_idx.

c2:
do on error undo, leave c2:
   run input_output_int16_cdecl (input-output num) no-error.
   message "Does not reach here c2.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'short into input-output integer' test but found" num.

run reset_idx.

c3:
do on error undo, leave c3:
   run input_output_uint16_cdecl (input-output num) no-error.
   message "Does not reach here c3.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'unsigned-short into input-output integer' test but found" num.

run reset_idx.

c4:
do on error undo, leave c4:
   run input_output_int32_cdecl (input-output num) no-error.
   message "Does not reach here c4.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'long into input-output integer' test but found" num.
   
run reset_idx.

c5:
do on error undo, leave c5:
   run input_output_uint32_cdecl (input-output num) no-error.
   message "Does not reach here c5.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'unsigned-long into input-output integer' test but found" num.
   
run reset_idx.

c6:
do on error undo, leave c6:
   run input_output_int64_cdecl (input-output num) no-error.
   message "Does not reach here c6.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'int64 into input-output integer' test but found" num.
   
run reset_idx.

c7:
do on error undo, leave c7:
   run input_output_uint8_cdecl (input-output num64) no-error.
   message "Does not reach here c7.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'byte into input-output int64' test but found" num64.

run reset_idx.

c8:
do on error undo, leave c8:
   run input_output_int16_cdecl (input-output num64) no-error.
   message "Does not reach here c8.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'short into input-output int64' test but found" num64.

run reset_idx.

c9:
do on error undo, leave c9:
   run input_output_uint16_cdecl (input-output num64) no-error.
   message "Does not reach here c9.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'unsigned-short into input-output int64' test but found" num64.

run reset_idx.

c10:
do on error undo, leave c10:
   run input_output_int32_cdecl (input-output num64) no-error.
   message "Does not reach here c10.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'long into input-output int64' test but found" num64.
   
run reset_idx.

c11:
do on error undo, leave c11:
   run input_output_uint32_cdecl (input-output num64) no-error.
   message "Does not reach here c11.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'unsigned-long into input-output int64' test but found" num64.
   
run reset_idx.

c12:
do on error undo, leave c12:
   run input_output_int64_cdecl (input-output num64) no-error.
   message "Does not reach here c12.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'int64 into input-output int64' test but found" num64.
   
run reset_idx.

/* decimal cases act the same way as decimal return parms */
c13:
do on error undo, leave c13:
   run input_output_float_cdecl (input-output dnum) no-error.
   message "Does not reach here c13.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'float into input-output decimal' test but found" dnum.

run reset_idx.

c14:
do on error undo, leave c14:
   run input_output_double_cdecl (input-output dnum) no-error.
   message "Does not reach here c14.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected error 12272 from 'double into input-output decimal' test but found" dnum.
   
run reset_idx.

/* Unknown value is not good for some pointer-based types. */

/* with output parms this error is 12450 instead of 12272; but both cases generate an ERROR, even if NO-ERROR is present! */
c15:
do on error undo, leave c15:
   run input_output_char_ptr_cdecl (input-output txt) no-error.
   message "Does not reach here c15.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected an error passing an unknown character var for an input-output parameter (got '" + txt + "').". 
   
/* This just silently returns with no changes and no error raised. */
run input_output_char_ptr_cdecl (input-output ltxt) no-error.
if not error-status:error or not error-status:get-number(1) eq 12450 then message "Expected an error passing an unknown longchar var for an input-output parameter (got '" + string(ltxt) + "').". 

txt = "".

/* This just silently returns with no changes and no error raised, but the API is called! */
run input_output_char_ptr_cdecl (input-output txt) no-error.
if txt ne "" then message "Expected a silent return from passing an empty character var for an input-output parameter (got '" + txt + "').". 

ltxt = "".
   
/* This just silently returns BEFORE actually calling the API with no changes and no error raised. */
run input_output_char_ptr_cdecl (input-output ltxt) no-error.
if ltxt ne "" then message "Expected a silent return from passing an empty longchar var for an input-output parameter (got '" + string(ltxt) + "').". 

/* different from return parms: this generates an error instead of abending the process */
/* different from output parms: this generates error 12272 instead of 3233 */
ptr = ?.
c16:
do on error undo, leave c16:
   run input_output_void_ptr_cdecl (input-output ptr) no-error.
   message "Does not reach here c16.".
end.
if not error-status:error or not error-status:get-number(1) eq 12272 then message "Expected an error passing an unknown memptr var for an input-output parameter (got '" + string(get-pointer-value(ptr)) + "').". 

/* different from return parms: this generates an error instead of actually working */
/* DLL procedure input_output_void_ptr_cdecl /home/someone/p93898_output_parameter_unknown_value.ped using an uninitialised MEMPTR. (3233) */
run input_output_void_ptr_cdecl (input-output uninitialized-ptr) no-error.
if not error-status:error or not error-status:get-number(1) eq 3233 then message "Expected an error passing an uninitialized memptr var for an input-output parameter (got '" + string(get-pointer-value(uninitialized-ptr)) + "').". 

/* different from return parms: this generates an error instead of abending the process */
/* DLL procedure input_output_void_ptr_cdecl /home/someone/p93898_output_parameter_unknown_value.ped using an uninitialised MEMPTR. (3233) */
set-size(uninitialized-ptr) = 0.
run input_output_void_ptr_cdecl (input-output uninitialized-ptr) no-error.
if not error-status:error or not error-status:get-number(1) eq 3233 then message "Expected an error passing a 0 size memptr var for an input-output parameter (got '" + string(get-pointer-value(uninitialized-ptr)) + "').".
   
set-size(blk) = 0.

{library_calls/input_output/input_output_parameter_end.i}

procedure set_memory_buffer external "{&libname}" cdecl persistent:
   def input parameter ptr as int64.
   def input parameter sz as long.
end.

procedure reset_idx external "{&libname}" cdecl:
end.

procedure input_output_uint8_cdecl external "{&libname}" cdecl:
   def input-output parameter r as byte.
end.

procedure input_output_int16_cdecl external "{&libname}" cdecl:
   def input-output parameter r as short.
end.

procedure input_output_uint16_cdecl external "{&libname}" cdecl:
   def input-output parameter r as unsigned-short.
end.

procedure input_output_int32_cdecl external "{&libname}" cdecl:
   def input-output parameter r as long.
end.

procedure input_output_uint32_cdecl external "{&libname}" cdecl:
   def input-output parameter r as unsigned-long.
end.

procedure input_output_int64_cdecl external "{&libname}" cdecl:
   def input-output parameter r as int64.
end.

procedure input_output_float_cdecl external "{&libname}" cdecl:
   def input-output parameter r as float.
end.

procedure input_output_double_cdecl external "{&libname}" cdecl:
   def input-output parameter r as double.
end.

procedure input_output_char_ptr_cdecl external "{&libname}" cdecl:
   def input-output parameter r as char.
end.

procedure input_output_void_ptr_cdecl external "{&libname}" cdecl:
   def input-output parameter r as memptr.
end.

run log-it (input "input_output_parameter_unknown_value end").
