{library_calls/log_hlp.i}

def var sz as int64.
def var ptr as memptr.
def var dd as decimal.

/* the PROCEDURE EXTERNAL library name MUST be a string literal, otherwise it is a compile error in 4GL */

run log-it (input "load_successes start").

&if "{&OPSYS}" eq "win32" &then
   /* omitting the DLL extension or using mismatching case names is not a problem for windows */
   
   run log-it (input "win32 load without pathing - testapi.dll").
   run dvalues_size (output sz).
   
   run log-it (input "win32 load without DLL extension - testapi").
   run ivalues_size (output sz).
   
   run log-it (input "win32 load case-insensitive - teSTapi.DlL").
   run ptr_size (output sz).
   
   run log-it (input "win32 load relative - library_path\testapi\testapi.dll").
   set-size(ptr) = sz * 8.
   run copy_ivalues (input-output ptr).
   set-size(ptr) = 0.
      
   run log-it (input "win32 load relative no DLL extension - library_path\testapi\testapi").
   run return_int64_cdecl (output dd).
   
   run log-it (input "win32 load absolute - c:\library_path\testapi\testapi.dll").
   run init_dvalues.
   
   run log-it (input "win32 load absolute no DLL extension - c:\library_path\testapi\testapi").
   run reset_idx.
   
   /* no DLL extension */
   procedure ivalues_size external "testapi" cdecl:
      define return parameter sz as long.
   end.
   
   procedure dvalues_size external "testapi.dll" cdecl:
      define return parameter sz as long.
   end.
   
   /* case-sensitive mismatch */
   procedure ptr_size external "teSTapi.DlL" cdecl:
      def return parameter sz as long.
   end.
   
   /* relative path */
   procedure copy_ivalues external "library_path\testapi\testapi.dll" cdecl:
      define input-output parameter buf as memptr.
   end.
   
   /* relative path, no DLL extension */
   procedure return_int64_cdecl external "library_path\testapi\testapi" cdecl:
      def return parameter dd as double.
   end.
   
   /* absolute path */
   procedure init_dvalues external "c:\library_path\testapi\testapi.dll" cdecl:
   end.

   /* absolute path, no DLL extension */
   procedure reset_idx external "c:\library_path\testapi\testapi" cdecl:
   end.
&else
   /* linux/unix must have the .so, the lib prefix and matching case */

   run log-it (input "linux/unix load without pathing - libtestapi.so").
   run ivalues_size (output sz).
   
   run log-it (input "linux/unix load relative pathing - library_path/testapi/libtestapi.so").
   run dvalues_size (output sz).
   
   run log-it (input "linux/unix load absolute path - /usr/lib/libtestapi.so").
   run ptr_size (output sz).
   
   /* search path */
   procedure ivalues_size external "libtestapi.so":
      define return parameter sz as long.
   end.
   
   /* relative path */
   procedure dvalues_size external "library_calls/testapi/libtestapi.so":
      define return parameter sz as long.
   end.
   
   /* absolute path */
   procedure ptr_size external "/usr/lib/libtestapi.so":
      def return parameter sz as long.
   end.
&endif

run log-it (input "load_successes end").
