{library_calls/log_hlp.i}

def var txt as char.
def var i as int.

/* the following cause no errors whatsoever, the libname arg is an expression whose */
/* value can never cause an error */

run log-it (input "release_external_test start").

/* these can't ever work */
txt = "".
release external txt.

/* this one causes a silent error (even when NO-ERROR is missing!) to be raised */
/* there is no error text or error number shown on the terminal OR recorded in error-status */
txt = ?.
release external txt no-error.
if not error-status:error then message "This call should have caused an ERROR condition.".
   
txt = "some librarY NamE that would never %&*A^@#!)(&^% exist".
release external txt.
txt = "/toTal_garBage/no-such_dIrecTORy/some librarY NamE that would never %&*A^@#!)(&^% exist".
release external txt.
txt = "no-such_dIrecTORy/some librarY NamE that would never %&*A^@#!)(&^% exist".
release external txt.
txt = "./some librarY NamE that would never %&*A^@#!)(&^% exist".
release external txt.

&if "{&OPSYS}" eq "win32" &then
   run log-it (input "RELEASE EXTERNAL 'testapi'.").
   release external "testapi".
   run log-it (input "RELEASE EXTERNAL 'testapi.dll'.").
   release external "testapi.dll".
&else
   /* release external never seems to work on Linux */
   
   /* these should not work since they don't work for loading either, they silently fail */
   run log-it (input "RELEASE EXTERNAL 'testapi'.").
   release external "testapi".
   run log-it (input "RELEASE EXTERNAL 'testapi.so'.").
   release external "testapi.so".
   run log-it (input "RELEASE EXTERNAL 'libteSTapi.so'.").
   release external "libteSTapi.so".
   run log-it (input "RELEASE EXTERNAL 'no-such_dIrecTORy/libtestapi.so'.").
   release external "no-such_dIrecTORy/libtestapi.so".
   run log-it (input "RELEASE EXTERNAL '/toTal_garBage/no-such_dIrecTORy/libtestapi.so'.").
   release external "/toTal_garBage/no-such_dIrecTORy/libtestapi.so".
   
   /* this one should work, but doesn't */
   run log-it (input "RELEASE EXTERNAL 'libtestapi.so'.").
   release external "libtestapi.so".
   
   /* try to see if this is reference counted (100 should be way more than the number of calls so far) */
   do i = 1 to 100:
      run log-it (input "RELEASE EXTERNAL 'libtestapi.so'. - iteration " + string(i)).
      release external "libtestapi.so".
   end.
   
   /* this one should work if that is the correct relative path for the library, but doesn't work */
   run log-it (input "RELEASE EXTERNAL 'library_calls/testapi/libtestapi.so'.").
   release external "library_calls/testapi/libtestapi.so".
   
   /* this one should work if that is the correct absolute path for the library, but doesn't work */
   run log-it (input "RELEASE EXTERNAL '/usr/lib/libtestapi.so'.").
   release external "/usr/lib/libtestapi.so".
&endif

run log-it (input "release_external_test end").

