{library_calls/log_hlp.i}
{library_calls/libname.i}

def var i as int.
def var errmsg as char.

run log-it (input "find_by_ordinal start").

/* non-existent ordinal (and function name) */
run some-unknown-garbage-function-name no-error.
errmsg = error-status:get-message(1).
if not error-status:error or
   not error-status:get-number(1) eq 3259 or
   not errmsg = "Could not find the entrypoint 15557. (3259)"
   then message "Expected error 3259 for missing ordinal. Got '" + errmsg + "'.".

/* function name is honored, found and used, the ordinal is ignored */
run ptr_size (output i).
if i ne 4 and i ne 8 then message "Expected a valid pointer size to be returned.  Got '" + string(i) + "'.".

&if "{&OPSYS}" eq "win32" &then
   /* windows specific case: the function only exists by ordinal */
   run ptr_size_by_ordinal (output i).
   if i ne 4 and i ne 8 then message "Expected a valid pointer size to be returned via ordinal.  Got '" + string(i) + "'.".
   
   /* the function name does not exist but the ordinal does */
   procedure ptr_size_by_ord external "{&libname}" cdecl ordinal 14:
      def return parameter sz as long.
   end.
&endif

run log-it (input "find_by_ordinal end").

/* neither the function name nor the ordinal exist */
procedure some-unknown-garbage-function-name external "{&libname}" cdecl ordinal 15557:
end.

/* the function name exists but the ordinal does not */
procedure ptr_size external "{&libname}" cdecl ordinal 15557:
   def return parameter sz as long.
end.
