{library_calls/log_hlp.i}
{library_calls/libname.i}

def var i as int.
def var rc as int.

run log-it (input "name_decoration start").

/* does the 4GL have a lookup algorithm that uses an _ prefixed function name if the */
/* undecorated function name cannot be found? NO, it DOESN'T! */
run underscore_prefixed_function_name (output rc) no-error.
if not error-status:error or
   not error-status:get-number(1) eq 3260
   then message "Expected error 3260 for mismatched function name (1). Got '" + error-status:get-message(1) + "'.".
   
rc = 0.
run _underscore_prefixed_function_name (output rc).
if rc <> 1 then message "Expected rc = 1 but got " + string(rc) + " (1).".
   
run ptr_size (output i).
if i ne 4 and i ne 8 then message "Expected a valid pointer size to be returned.  Got '" + string(i) + "'.".

/* windows 32-bit specific case (STDCALL decorations) */
if opsys eq "win32" and i = 4 then
do:

   /* does the 4GL have a lookup algorithm that uses an @ num suffixed function name if the */
   /* undecorated function name cannot be found? NO, it DOESN'T! */
   
   rc = 0.
   run function_name_with_at_suffix (input 14, output rc) no-error.
   if not error-status:error or
      not error-status:get-number(1) eq 3260
      then message "Expected error 3260 for mismatched function name (2). Got '" + error-status:get-message(1) + "'.".
   
   rc = 0.
   run underscore_prefixed_function_name_with_at_suffix (input 14, output rc) no-error.
   if not error-status:error or
      not error-status:get-number(1) eq 3260
      then message "Expected error 3260 for mismatched function name (3). Got '" + error-status:get-message(1) + "'.".
   
   rc = 0.
   run function_name_with_at_suffix@4 (input 14, output rc).
   if rc <> 1 then message "Expected rc = 1 but got " + string(rc) + " (2).".
   
   rc = 0.
   run _underscore_prefixed_function_name_with_at_suffix@4 (input 14, output rc).
   if rc <> 1 then message "Expected rc = 1 but got " + string(rc) + " (3).".
   
   procedure function_name_with_at_suffix external "{&libname}" stdcall:
      def input parameter sz as long.
      def return parameter i as long.
   end.
   
   procedure underscore_prefixed_function_name_with_at_suffix external "{&libname}" stdcall:
      def input parameter sz as long.
      def return parameter i as long.
   end.

   procedure function_name_with_at_suffix@4 external "{&libname}" stdcall:
      def input parameter sz as long.
      def return parameter i as long.
   end.
   
   procedure _underscore_prefixed_function_name_with_at_suffix@4 external "{&libname}" stdcall:
      def input parameter sz as long.
      def return parameter i as long.
   end.
end.

run log-it (input "name_decoration end").

/* this function name doesn't exist */
procedure underscore_prefixed_function_name external "{&libname}" cdecl:
   def return parameter i as long.
end.

/* this function name does exist */
procedure _underscore_prefixed_function_name external "{&libname}" cdecl:
   def return parameter i as long.
end.

procedure ptr_size external "{&libname}" cdecl:
   def return parameter sz as long.
end.
