{library_calls/log_hlp.i}

/* this shows a native API call AND it shows the default calling convention */
/* (cdecl for Linux and stdcall for windows 32-bit, fastcall for windows 64-bit) */

run log-it (input "os_api_call start").

def var ptr as memptr.
def var txt-ptr as memptr.
def var txt1 as char.
def var txt2 as char.
def var addr1 as int64.
def var addr2 as int64.
def var num as int.
def var err-flag as logical.
def var pointer-size as int.

err-flag = true.

run library_calls/read_pointer_size.p (output pointer-size).

/* windows 32-bit stdcall case */
if opsys eq "win32" and pointer-size = 4 then
do:
   set-size(ptr) = 8192.
   run getcwd (input 8192, output ptr, output num).
   txt1 = get-string(ptr, 1).
   set-size(ptr) = 0.
   if num <= 0 or txt1 eq ? or length(txt1) = 0 then message "GetCurrentDirectory() unexpected failure; num = " + string(num).
   run log-it (input "cwd = " + txt1).
   err-flag = false.
end.
else
do:
   set-size(ptr) = 256.
   addr1 = get-pointer-value(ptr).
   run getcwd (output ptr, input 256, output txt-ptr).
   txt1 = get-string(ptr, 1).
   txt2 = get-string(txt-ptr, 1).
   addr2 = get-pointer-value(txt-ptr).
   set-size(ptr) = 0.
   if txt1 ne txt2 then message "getcwd() unexpected text output; txt1 = " + txt1 + "; txt2 = " + txt2.
   if addr1 ne addr2 then message "getcwd() unexpected address mismatch; addr1 = " + string(addr1) + "; addr2 = " + string(addr2).
   run log-it (input "cwd = " + txt1).
   err-flag = false.
end.

if err-flag then message "Bad things happened!".

run log-it (input "os_api_call end").

procedure GetCurrentDirectory external "kernel32":
   def input  parameter sz  as long.
   def output parameter buf as memptr.
   def return parameter num as long.
end.

procedure getcwd external "libc.so.6":
   def output parameter buf as memptr.
   def input  parameter sz  as long.
   def return parameter txt as memptr.
end.


