{library_calls/log_hlp.i}

run log-it (input "{&apiname} reading {&apitype} into decimal start").

{library_calls/libname.i}

/* allocating and deallocating this in each included section results in the */
/* memory being cleared before each test, which is important */
set-size(results) = sz * 8.

/* message "Running {&apiname}() reading {&apitype} into decimal.". */

if (sz * 2) ne extent(dnum_array) then message "ERROR: hard coded extent size" extent(dnum_array) "should be set to" (sz * 2) "!". 

do i = 1 to sz:

   err-flag = true.
   inner:
   do on error undo, leave inner:
      run {&apiname} (output dnum).
      err-flag = false.
   end.
   if err-flag then
      message "Failure occured in {&apiname}() - {&apitype} into decimal for entry: " i ".".
   
   /* save results into buffer */
   idx = ((i - 1) * 8) + 1.
   put-double(results, idx) = dnum.
end.

copy-lob results to file "{&apiname}_{&apitype}_into_decimal.out".

/* This call will cause numerous messages to be displayed if run without NO-ERROR. */
/* The messages are not treated as "errors", so the ERROR condition is not raised */
/* and when NO-ERROR is used there is no update of the ERROR-STATUS list of errors. */
/* The messages are one of these two: */
/*   Insufficient space for float to decimal conversion. (86) */
/*   Decimal number is too large. (536) */
/* The problem seems to be some mismatch with the 4GL using float data types and */
/* the native side using double.  However, there are even a large number of problems */
/* reported in the double/double case and in native float API + 4GL using double */
/* The float/float case is the only one that has no messages. */
run {&apiname}_array (output dnum_array) no-error.

if error-status:error then
do:
   err-list = "".
   do i = 1 to error-status:num-messages:
      err-list = err-list + string(error-status:get-number(i)) + " ".
   end.
   message err-list.
end.

set-size(results) = 0.
set-size(results) = extent(dnum_array) * 8.

/* save results into buffer */
do i = 1 to extent(dnum_array):
   idx = ((i - 1) * 8) + 1.
   put-double(results, idx) = dnum_array[i].
end.

copy-lob results to file "{&apiname}_{&apitype}_array_into_decimal.out".

/*
do i = 1 to sz:
   idx = ((i - 1) * 8) + 1.
   dscratch = get-double(results, idx).
   if dnum_array[i] ne dscratch then message "Expected" dscratch "but read" dnum_array[i] "from element" i ".".
end.
*/

set-size(results) = 0.

procedure {&apiname} external "{&libname}" {&callconv}:
   define output parameter d as {&apitype}.
end.

procedure {&apiname}_array external "{&libname}" {&callconv}:
   define output parameter d as {&apitype}.
end.

run log-it (input "{&apiname} reading {&apitype} into decimal end").

