{library_calls/log_hlp.i}

run log-it (input "return_char_ptr_into_memptr_{&callconv} start").

{library_calls/libname.i}

def var txt as character init "bogus".
def var ptr as memptr.
def var ptr2ptr as memptr.
def var addr1 as int64.
def var addr2 as int64.
def var sz as int.

/* this will initialize the memptr to point to the DLL memory that contains a */
/* null-terminated string */
run return_char_ptr_{&callconv} (output ptr).
txt = get-string(ptr, 1).
if txt ne "This is sample text!" then message "Unexpected text returned via memptr ('" + txt + "').".

/* this will initialize the memptr to point to the DLL memory that contains a */
/* pointer to the DLL memory that contains a null-terminated string */
run return_char_ptr_ptr_{&callconv} (output ptr2ptr).

run ptr_size (output sz).
addr1 = get-pointer-value(ptr).

if sz = 4 then
   addr2 = get-long(ptr2ptr, 1).
else
   addr2 = get-int64(ptr2ptr, 1).

if addr1 ne addr2 then message "Expected address" addr1 "and got" addr2 ".". 

/* no de-allocation of the memptrs is needed since we don't "own" the memory, the DLL does */

release external "{&libname}".

procedure ptr_size external "{&libname}" cdecl persistent:
   def return parameter sz as long.
end.

procedure return_char_ptr_{&callconv} external "{&libname}" {&callconv} persistent:
   def return parameter ptr as memptr.
end.

procedure return_char_ptr_ptr_{&callconv} external "{&libname}" {&callconv} persistent:
   def return parameter ptr as memptr.
end.

run log-it (input "return_char_ptr_into_memptr_{&callconv} end").
