{library_calls/log_hlp.i}

run log-it (input "{&apiname} - parm type {&apitype} into actual library type {&rettype} start").

{library_calls/libname.i}

/* allocating and deallocating this in each included section results in the */
/* memory being cleared before each test, which is important */
set-size(results) = sz * 8.

/* potential overflow case requires checking below */
/* &vartype is the 4GL variable type to which we are assigning */
/* &apitype is the 4GL shared library type name that is used to interpret the returned value */
/* &rettype is the actual shared library function type being returned */
s-overflow = ("{&vartype}" eq "integer") and ("{&apitype}" eq "int64") and ("{&rettype}" eq "int64").
n-overflow = ("{&vartype}" eq "integer") and ("{&apitype}" eq "int64") and ("{&rettype}" eq "int32" or "{&rettype}" eq "uint32").
u-overflow = ("{&vartype}" eq "integer") and ("{&apitype}" eq "unsigned-long") and ("{&rettype}" eq "int32" or "{&rettype}" eq "uint32" or "{&rettype}" eq "int64").
                                             
do i = 1 to sz:

   /* make the call being tested */
   if (s-overflow and (ilist[i] < -2147483648 or ilist[i] > 2147483647)) or
      ((n-overflow or u-overflow) and get-bits(ilist[i], 32, 1) eq 1) then
   do:
      /* deal with the overflow case */
      run {&apiname} (output {&varname}) no-error.
      if not error-status:error or not error-status:get-number(1) eq 15747 then message "Unexpected result in {&apiname}() - {&apitype} into {&vartype} for value (ori:" ilist[i] "; entry: " i "; read: " {&varname} ").".
   end.
   else
   do:
      err-flag = true.
      inner:
      do on error undo, leave inner:
         run {&apiname} (output {&varname}).
         err-flag = false.
      end.
      if err-flag then
         message "Failure occured in {&apiname}() - {&apitype} into {&vartype} for value (ori:" ilist[i] "; entry:" i ").".
   end.
   
   /* save results into buffer */
   idx = ((i - 1) * 8) + 1.
   put-int64(results, idx) = {&varname}.
end.

copy-lob results to file "{&apiname}_{&apitype}_into_{&vartype}.out".

set-size(results) = 0.

procedure {&apiname} external "{&libname}" {&callconv}:
   define return parameter {&varname} as {&apitype}.
end.

run log-it (input "{&apiname} - parm type {&apitype} into actual library type {&rettype} end").
