{library_calls/log_hlp.i}

run log-it (input "return_void_ptr_{&callconv} start").

{library_calls/libname.i}

def var block as memptr.
def var ptr as memptr.
def var ptr2ptr as memptr.
def var addr1 as int64.
def var addr2 as int64.
def var addr3 as int64.
def var i as int.
def var b as int.
def var sz as int.

set-size(block) = 16.
addr1 = get-pointer-value(block).
run set_memory_buffer (addr1, 16).

do i = 1 to 16:
   put-byte(block, i) = i + 64.
end.

run return_void_ptr_{&callconv} (output ptr).
addr2 = get-pointer-value(ptr).

if addr1 ne addr2 then message "Expected address" addr1 "and got" addr2 ".". 

do i = 1 to 16:
   b = get-byte(ptr, i).
   if b ne (i + 64) then message "Expected byte value" (i + 64) "and instead found" b.
end.

run ptr_size (output sz).
run return_void_ptr_ptr_{&callconv} (output ptr2ptr).

if sz = 4 then
   addr3 = get-long(ptr2ptr, 1).
else
   addr3 = get-int64(ptr2ptr, 1).

if addr1 ne addr3 then message "Expected (2) address" addr1 "and got" addr3 ".". 

/* we don't need to de-allocate ptr since it is just a duplicate of block */
set-size(block) = 0.
release external "{&libname}".

procedure set_memory_buffer external "{&libname}" cdecl persistent:
   def input parameter ptr as int64.
   def input parameter sz as long.
end.

procedure ptr_size external "{&libname}" cdecl persistent:
   def return parameter sz as long.
end.

procedure return_void_ptr_{&callconv} external "{&libname}" {&callconv} persistent:
   def return parameter ptr as memptr.
end.

procedure return_void_ptr_ptr_{&callconv} external "{&libname}" {&callconv} persistent:
   def return parameter ptr as memptr.
end.

run log-it (input "return_void_ptr_{&callconv} end").
