#include "helper.h"

int64_t ivalues[] = { 
   0,
   1,
   2,                                                  
   3, 
   4,
   5,
   6,
   7,
   8,
   9,
   10,
   11,
   12,
   13,
   14,
   15,
   16,
   17,
   127,
   128,
   255,
   256,
   1023,
   1024,
   16383,
   16384,
   32767,
   32768,
   65535,
   65536,
   2147483647,
   2147483648,
   4294967295,
   4294967296,
   INT64_MAX,      // should be 9223372036854775807
   -1,
   -2,                                                  
   -3, 
   -4,
   -5,
   -6,
   -7,
   -8,
   -9,
   -10,
   -11,
   -12,
   -13,
   -14,
   -15,
   -16,
   -17,
   -128,
   -129,
   -256,
   -257,
   -1024,
   -1025,
   -16384,
   -16385,
   -32768,
   -32769,
   -65536,
   -65537,
   -2147483648,
   -2147483649,
   -4294967296,
   -4294967297,
   INT64_MIN };  // should be -9223372036854775808 BUT specifying this triggers a compiler
                 // warning because it is really taking 9223372036854775808 (too big for
                 // a signed 64-bit integer) and negating it
   
int i_idx = 0;
int64_t mask = 0;

int i_len = (sizeof ivalues / sizeof ivalues[0]);

double dvalues[((sizeof ivalues / sizeof ivalues[0]) * 4)];
int d_idx = 0;

char* text = "This is sample text!";
char* other = NULL;
int o_len = 0;

int64_t num64 = 14;

int d_len = (sizeof dvalues / sizeof dvalues[0]);

DLL_EXPORT int CDECL ivalues_size() { return i_len; }
DLL_EXPORT int CDECL dvalues_size() { return d_len; }
DLL_EXPORT int CDECL ptr_size() { return sizeof other; }

#ifdef WINDOWS
   /* this is not exported by default (no DLL_EXPORT entry), but on windows */
   /* this will be exported by ordinal using a DEF file */
   int CDECL alternate_ptr_size() { return ptr_size(); }
#endif

DLL_EXPORT void CDECL reset_idx() { i_idx = 0; d_idx = 0; }

DLL_EXPORT void CDECL copy_ivalues(int64_t* nums)
{
   if (nums != NULL)                                                      
   {
      for (int i = 0; i < i_len; i++)
      {
         nums[i] = ivalues[i];
      }
   }
}

DLL_EXPORT void CDECL init_dvalues()
{
   for (int i = 0; i < i_len; i++)
   {
      dvalues[i]                     = (double) ivalues[i];
      dvalues[i + i_len]       = dvalues[i] - (dvalues[i] / 3);
      dvalues[i + (i_len * 2)] = (dvalues[i] / 3);
      dvalues[i + (i_len * 3)] = (dvalues[i] / 7);
   }
}

DLL_EXPORT void CDECL copy_dvalues(double* nums)
{
   if (nums != NULL)                                                      
   {
      for (int i = 0; i < d_len; i++)
      {
         nums[i] = dvalues[i];
      }
   }
}

DLL_EXPORT void CDECL set_memory_buffer(int64_t ptr, int sz)
{
   #ifdef BIT32
      int pval = (int) ptr;
      other = (void*) pval;
   #endif
   
   #ifdef BIT64
      other = (void*) ptr;
   #endif
   
   o_len = sz;
}

DLL_EXPORT int CDECL get_memory_buffer_size() { return o_len; }
