
#include <inttypes.h>

// this is a simple way to zero out the integer return register

#ifdef __i386__
   #define ARCH_X86
   #define BIT32
   #define CLEAR_RETURN_REGISTER  __asm__("xor %eax, %eax\n\t" "xor %edx, %edx");
#endif

#ifdef __x86_64__
   #define ARCH_X86_64
   #define BIT64
   #define CLEAR_RETURN_REGISTER  __asm__("xor %rax, %rax");
#endif

#ifdef __sparc__
   #define ARCH_SPARC
   #define BIT64
   // TODO: fix this for sparc instruction set
   #define CLEAR_RETURN_REGISTER  __asm__("?????????");
#endif

// OS-specific defines

#ifdef LINUX
   #define STDCALL
   #define CDECL
   #define DLL_EXPORT __attribute__ ((visibility ("default")))
   #define DLL_HIDE   __attribute__ ((visibility ("hidden")))
   #define NULL   ((void *) 0)
#endif

#ifdef SOLARIS
   #define STDCALL
   #define CDECL
   #define DLL_EXPORT __attribute__ ((visibility ("default")))
   #define DLL_HIDE   __attribute__ ((visibility ("hidden")))
   #define NULL   ((void *) 0)
#endif

#ifdef WINDOWS32
   #define STDCALL   __attribute__((__stdcall__))
   #define CDECL     __attribute__((__cdecl__))
   #define DLL_EXPORT __attribute__ ((dllexport))
   #define DLL_HIDE
#endif

#ifdef WINDOWS64
   #define STDCALL
   #define CDECL
   #define DLL_EXPORT __attribute__ ((dllexport))
   #define DLL_HIDE
#endif

// common function declarations
void flog(char* spec, ...);
void log_bytes(char* prefix, char* postfix, void* ptr, int len);
void copy_uint8_value(uint8_t * val);
void copy_int16_value(int16_t * val);
void copy_uint16_value(uint16_t * val);
void copy_int32_value(int32_t * val);
void copy_uint32_value(uint32_t * val);
void copy_int64_value(int64_t * val);
void copy_float_value(float * val);
void copy_double_value(double * val);
