
#include "helper.h"
#include <windows.h>

// CRT initialization prototype
BOOL WINAPI _CRT_INIT(HINSTANCE handle, DWORD reason, LPVOID reserved); 

BOOL WINAPI DllMain(HINSTANCE handle, DWORD reason, LPVOID reserved)
{
   if (reason == DLL_PROCESS_ATTACH || reason == DLL_THREAD_ATTACH)
   {
      // do not access C runtime functions before here
      if (!_CRT_INIT(handle, reason, reserved))
      {
         return (FALSE);
      }
      
      flog("LOAD\n");
   }

   if (reason == DLL_PROCESS_DETACH || reason == DLL_THREAD_DETACH)
   {
      flog("UNLOAD\n");

      // no C runtime usage after this point
      if (!_CRT_INIT(handle, reason, reserved))
      {
         return (FALSE);
      }
   }
   
   return (TRUE);
}
