
#include "helper.h"
#include <string.h>
#include <stdio.h>

extern int64_t ivalues[];
extern int i_idx;
extern int64_t mask;
extern int i_len;
extern double dvalues[];
extern int d_idx;
extern int d_len;
extern char* text;
extern char* other;
extern int o_len;
extern int64_t num64;

DLL_EXPORT int64_t CDECL overflowInt32(int64_t* i1, int64_t* i2, int64_t* i3, int flag)
{
   if (*i1 > 0)
      *i1 = INT64_MAX;
   if (*i1 < 0)
      *i1 = INT64_MIN;
   if (*i2 > 0)
      *i2 = INT64_MAX;
   if (*i2 < 0)
      *i2 = INT64_MIN;
   if (*i3 > 0)
      *i3 = INT64_MAX;
   if (*i3 < 0)
      *i3 = INT64_MIN;
   
   return flag > 0 ?  INT64_MAX : (flag < 0 ? INT64_MIN : 0);
}

#define INOUTFUNC(typ, spec, cconv, fname, gname)  DLL_EXPORT void cconv fname(typ * val)\
{\
   flog(#fname "(" #typ " value = %" #spec ")\n", *val);\
   gname(val);\
}

#define INOUTIARRAY(typ, cconv, fname, maskval)  DLL_EXPORT void cconv fname(typ * val)\
{\
   mask = maskval;\
\
   flog(#fname "() with mask 0x%016X and input values:", mask);\
\
   for (int i = 0; i < i_len; i++)\
   {\
      flog(" 0x%016X,", val[i]);\
      val[i] = (ivalues[i] & mask);\
   }\
\
   flog("\n");\
}

#define INOUTDARRAY(typ, cconv, fname, gname)  DLL_EXPORT void cconv fname(typ * val) { gname(val, d_len, 0); } 

#define INOUTDLIMITARRAY(typ, cconv, fname)  DLL_EXPORT void cconv fname(typ * val, int len, int idx)\
{\
   flog(#fname "() and input values:");\
\
   for (int i = 0; i < len; i++)\
   {\
      flog(" %g,", val[i]);\
      val[i] = dvalues[idx + i];\
   }\
\
   flog("\n");\
}

// CDECL functions
DLL_EXPORT void CDECL input_output_char_ptr_cdecl(char* ptr) { flog("input_output_char_ptr_cdecl(%s)\n", ptr ? ptr : "null"); strcpy(ptr, text); }
DLL_EXPORT void CDECL input_output_char_ptr_cdecl_array(char* ptr[], int len)
{
   int n = 0;
   
   flog("input_output_char_ptr_cdecl_array() and input values:");
   
   for (int i = 0; i < len; i++)
   {
      if (ptr[i] != NULL)
      {
         flog(" '%s',", ptr[i]);
         sprintf(ptr[i], "%i", i);
         n++;
      }
   }
   
   flog("; %i elements processed\n", n);
}

DLL_EXPORT void CDECL input_output_void_ptr_cdecl(void* ptr)
{
   log_bytes("input_output_void_ptr_cdecl() and input bytes: ", "\n", ptr, o_len);
   memcpy(ptr, other, o_len);
}

DLL_EXPORT void CDECL input_output_void_ptr_cdecl_array(void* ptr[], int len)
{
   int n = 0;
   
   flog("input_output_void_ptr_cdecl_array() and input values: ");
   
   for (int i = 0; i < len; i++)
   {
      if (ptr[i] != NULL)
      {
         log_bytes("", "", ptr[i], o_len);
         memcpy(ptr[i], other, o_len);
         n++;
      }
   }
   
   flog("- %i elements processed\n", n);
}

DLL_EXPORT void CDECL input_output_char_ptr_ptr_cdecl(char** ptrptr) { flog("input_output_char_ptr_ptr_cdecl(%s)\n", *ptrptr); *ptrptr = text; }
DLL_EXPORT void CDECL input_output_void_ptr_ptr_cdecl(void** ptrptr) { log_bytes("input_output_void_ptr_ptr_cdecl() and input values: ", "\n", *ptrptr, o_len); *ptrptr = (void*) other; }
DLL_EXPORT void CDECL input_output_int64_ptr_cdecl(int64_t* ptr) {  flog("input_output_int64_ptr_cdecl(%" PRId64 ")\n", *ptr); *ptr = num64; }

DLL_EXPORT void CDECL input_output_int32_3_parm_cdecl(int32_t* i1, int32_t* i2, int32_t* i3)
{
   flog("input_output_int32_3_parm_cdecl() and input values: %i, %i, %i\n", *i1, *i2, *i3);
   *i1 = 0x8FFFFF01; *i2 = 0x8FFFFF02; *i3 = 0x8FFFFF03;
}

DLL_EXPORT void CDECL input_output_int32_8_parm_cdecl(int32_t* i1, int32_t* i2, int32_t* i3, int32_t* i4, int32_t* i5, int32_t* i6, int32_t* i7, int32_t* i8)
{
   flog("input_output_int32_8_parm_cdecl() and input values: %i, %i, %i, %i, %i, %i, %i, %i\n", *i1, *i2, *i3, *i4, *i5, *i6, *i7, *i8);
   *i1 = 0x8FFFFF01; *i2 = 0x8FFFFF02; *i3 = 0x8FFFFF03; *i4 = 0x8FFFFF04; *i5 = 0x8FFFFF05; *i6 = 0x8FFFFF06; *i7 = 0x8FFFFF07; *i8 = 0x8FFFFF08;
}

DLL_EXPORT void CDECL input_output_int64_8_parm_cdecl(int64_t* i1, int64_t* i2, int64_t* i3, int64_t* i4, int64_t* i5, int64_t* i6, int64_t* i7, int64_t* i8)
{
   flog("input_output_int64_8_parm_cdecl() and input values: %" PRId64 ", %" PRId64 ", %" PRId64 ", %" PRId64 ", %" PRId64 ", %" PRId64 ", %" PRId64 ", %" PRId64 "\n", *i1, *i2, *i3, *i4, *i5, *i6, *i7, *i8);
   *i1 = 0x8FFFFFFFFFFFFF01; *i2 = 0x8FFFFFFFFFFFFF02; *i3 = 0x8FFFFFFFFFFFFF03; *i4 = 0x8FFFFFFFFFFFFF04; *i5 = 0x8FFFFFFFFFFFFF05; *i6 = 0x8FFFFFFFFFFFFF06; *i7 = 0x8FFFFFFFFFFFFF07; *i8 = 0x8FFFFFFFFFFFFF08;
}

DLL_EXPORT void CDECL input_output_double_8_parm_cdecl(double* d1, double* d2, double* d3, double* d4, double* d5, double* d6, double* d7, double* d8)
{
   flog("input_output_double_8_parm_cdecl() and input values: %g, %g, %g, %g, %g, %g, %g, %g\n", *d1, *d2, *d3, *d4, *d5, *d6, *d7, *d8);
   *d1 = 100 - *d1; *d2 = 100 - *d2; *d3 = 100 - *d3; *d4 = 100 - *d4; *d5 = 100 - *d5; *d6 = 100 - *d6; *d7 = 100 - *d7; *d8 = 100 - *d8;
}

DLL_EXPORT void CDECL input_output_float_8_parm_cdecl(float* f1, float* f2, float* f3, float* f4, float* f5, float* f6, float* f7, float* f8)
{
   flog("input_output_float_8_parm_cdecl() and input values: %g, %g, %g, %g, %g, %g, %g, %g\n", *f1, *f2, *f3, *f4, *f5, *f6, *f7, *f8);
   *f1 = 100 - *f1; *f2 = 100 - *f2; *f3 = 100 - *f3; *f4 = 100 - *f4; *f5 = 100 - *f5; *f6 = 100 - *f6; *f7 = 100 - *f7; *f8 = 100 - *f8;
}

DLL_EXPORT void CDECL input_output_char_ptr_8_parm_cdecl(char* c1, char* c2, char* c3, char* c4, char* c5, char* c6, char* c7, char* c8)
{
   flog("input_output_char_ptr_8_parm_cdecl() and input values: '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s'\n", c1, c2, c3, c4, c5, c6, c7, c8);
   strcpy(c1, "0"); strcpy(c2, "1"); strcpy(c3, "2"); strcpy(c4, "3"); strcpy(c5, "4"); strcpy(c6, "5"); strcpy(c7, "6"); strcpy(c8, "7");
}

INOUTFUNC(uint8_t, u, CDECL, input_output_uint8_cdecl, copy_uint8_value)
INOUTIARRAY(uint8_t, CDECL, input_output_uint8_cdecl_array, 0x00000000000000FFLL)

INOUTFUNC(int16_t, i, CDECL, input_output_int16_cdecl, copy_int16_value)
INOUTIARRAY(int16_t, CDECL, input_output_int16_cdecl_array, 0x000000000000FFFFLL)

INOUTFUNC(uint16_t, u, CDECL, input_output_uint16_cdecl, copy_uint16_value)
INOUTIARRAY(uint16_t, CDECL, input_output_uint16_cdecl_array, 0x000000000000FFFFLL)

// PRIi32 can't be used here because it is a macro and won't expand right
INOUTFUNC(int32_t, i, CDECL, input_output_int32_cdecl, copy_int32_value)
INOUTIARRAY(int32_t, CDECL, input_output_int32_cdecl_array, 0x00000000FFFFFFFFLL)

// PRIu32 can't be used here because it is a macro and won't expand right
INOUTFUNC(uint32_t, u, CDECL, input_output_uint32_cdecl, copy_uint32_value)
INOUTIARRAY(uint32_t, CDECL, input_output_uint32_cdecl_array, 0x00000000FFFFFFFFLL)

// PRId64 can't be used here because it is a macro and won't expand right, hopefully lld works on windows
INOUTFUNC(int64_t, lld, CDECL, input_output_int64_cdecl, copy_int64_value)
INOUTIARRAY(int64_t, CDECL, input_output_int64_cdecl_array, 0xFFFFFFFFFFFFFFFFLL)

INOUTFUNC(float, g, CDECL, input_output_float_cdecl, copy_float_value)
INOUTDLIMITARRAY(float, CDECL, input_output_float_cdecl_limit_array)
INOUTDARRAY(float, CDECL, input_output_float_cdecl_array, input_output_float_cdecl_limit_array)

INOUTFUNC(double, g, CDECL, input_output_double_cdecl, copy_double_value)
INOUTDLIMITARRAY(double, CDECL, input_output_double_cdecl_limit_array)
INOUTDARRAY(double, CDECL, input_output_double_cdecl_array, input_output_double_cdecl_limit_array)

// STDCALL functions (only emit on Windows 32-bit)
#ifdef WINDOWS32
INOUTFUNC(uint8_t, u, STDCALL, input_output_uint8_stdcall, copy_uint8_value)
INOUTIARRAY(uint8_t, STDCALL, input_output_uint8_stdcall_array, 0x00000000000000FFLL)

INOUTFUNC(int16_t, i, STDCALL, input_output_int16_stdcall, copy_int16_value)
INOUTIARRAY(int16_t, STDCALL, input_output_int16_stdcall_array, 0x000000000000FFFFLL)

INOUTFUNC(uint16_t, u, STDCALL, input_output_uint16_stdcall, copy_uint16_value)
INOUTIARRAY(uint16_t, STDCALL, input_output_uint16_stdcall_array, 0x000000000000FFFFLL)

// PRIi32 can't be used here because it is a macro and won't expand right
INOUTFUNC(int32_t, i, STDCALL, input_output_int32_stdcall, copy_int32_value)
INOUTIARRAY(int32_t, STDCALL, input_output_int32_stdcall_array, 0x00000000FFFFFFFFLL)

// PRIu32 can't be used here because it is a macro and won't expand right
INOUTFUNC(uint32_t, u, STDCALL, input_output_uint32_stdcall, copy_uint32_value)
INOUTIARRAY(uint32_t, STDCALL, input_output_uint32_stdcall_array, 0x00000000FFFFFFFFLL)

// PRId64 can't be used here because it is a macro and won't expand right, hopefully lld works on windows
INOUTFUNC(int64_t, lld, STDCALL, input_output_int64_stdcall, copy_int64_value)
INOUTIARRAY(int64_t, STDCALL, input_output_int64_stdcall_array, 0xFFFFFFFFFFFFFFFFLL)

INOUTFUNC(float, g, STDCALL, input_output_float_stdcall, copy_float_value)
INOUTDLIMITARRAY(float, STDCALL, input_output_float_stdcall_limit_array)
INOUTDARRAY(float, STDCALL, input_output_float_stdcall_array, input_output_float_stdcall_limit_array)

INOUTFUNC(double, g, STDCALL, input_output_double_stdcall, copy_double_value)
INOUTDLIMITARRAY(double, STDCALL, input_output_double_stdcall_limit_array)
INOUTDARRAY(double, STDCALL, input_output_double_stdcall_array, input_output_double_stdcall_limit_array)

DLL_EXPORT void STDCALL input_output_char_ptr_stdcall(char* ptr) { flog("input_output_char_ptr_stdcall(%s)\n", ptr); strcpy(ptr, text); }
DLL_EXPORT void STDCALL input_output_char_ptr_stdcall_array(char* ptr[], int len)
{
   int n = 0;
   
   flog("input_output_char_ptr_stdcall_array() and input values:");
   
   for (int i = 0; i < len; i++)
   {
      if (ptr[i] != NULL)
      {
         flog(" '%s',", ptr[i]);
         sprintf(ptr[i], "%i", i);
         n++;
      }
   }
   
   flog("; %i elements processed\n", n);
}

DLL_EXPORT void STDCALL input_output_void_ptr_stdcall(void* ptr) { log_bytes("input_output_void_ptr_stdcall() and input values: ", "\n", ptr, o_len); memcpy(ptr, other, o_len); }
DLL_EXPORT void STDCALL input_output_char_ptr_ptr_stdcall(char** ptrptr) { flog("input_output_char_ptr_ptr_stdcall(%s)\n", *ptrptr); *ptrptr = text; }
DLL_EXPORT void STDCALL input_output_void_ptr_ptr_stdcall(void** ptrptr) { log_bytes("input_output_void_ptr_ptr_stdcall() and input values: ", "\n", *ptrptr, o_len); *ptrptr = (void*) other; }

DLL_EXPORT void STDCALL input_output_int32_8_parm_stdcall(int32_t* i1, int32_t* i2, int32_t* i3, int32_t* i4, int32_t* i5, int32_t* i6, int32_t* i7, int32_t* i8)
{
   flog("input_output_int32_8_parm_stdcall() and input values: %i, %i, %i, %i, %i, %i, %i, %i\n", *i1, *i2, *i3, *i4, *i5, *i6, *i7, *i8);
   *i1 = 0x8FFFFF01; *i2 = 0x8FFFFF02; *i3 = 0x8FFFFF03; *i4 = 0x8FFFFF04; *i5 = 0x8FFFFF05; *i6 = 0x8FFFFF06; *i7 = 0x8FFFFF07; *i8 = 0x8FFFFF08;
}

DLL_EXPORT void STDCALL input_output_int64_8_parm_stdcall(int64_t* i1, int64_t* i2, int64_t* i3, int64_t* i4, int64_t* i5, int64_t* i6, int64_t* i7, int64_t* i8)
{
   flog("input_output_int64_8_parm_stdcall() and input values: %" PRId64 ", %" PRId64 ", %" PRId64 ", %" PRId64 ", %" PRId64 ", %" PRId64 ", %" PRId64 ", %" PRId64 "\n", *i1, *i2, *i3, *i4, *i5, *i6, *i7, *i8);
   *i1 = 0x8FFFFFFFFFFFFF01; *i2 = 0x8FFFFFFFFFFFFF02; *i3 = 0x8FFFFFFFFFFFFF03; *i4 = 0x8FFFFFFFFFFFFF04; *i5 = 0x8FFFFFFFFFFFFF05; *i6 = 0x8FFFFFFFFFFFFF06; *i7 = 0x8FFFFFFFFFFFFF07; *i8 = 0x8FFFFFFFFFFFFF08;
}

DLL_EXPORT void STDCALL input_output_double_8_parm_stdcall(double* d1, double* d2, double* d3, double* d4, double* d5, double* d6, double* d7, double* d8)
{
   flog("input_output_double_8_parm_stdcall() and input values: %g, %g, %g, %g, %g, %g, %g, %g\n", *d1, *d2, *d3, *d4, *d5, *d6, *d7, *d8);
   *d1 = 100 - *d1; *d2 = 100 - *d2; *d3 = 100 - *d3; *d4 = 100 - *d4; *d5 = 100 - *d5; *d6 = 100 - *d6; *d7 = 100 - *d7; *d8 = 100 - *d8;
}

DLL_EXPORT void STDCALL input_output_float_8_parm_stdcall(float* f1, float* f2, float* f3, float* f4, float* f5, float* f6, float* f7, float* f8)
{
   flog("input_output_float_8_parm_stdcall() and input values: %g, %g, %g, %g, %g, %g, %g, %g\n", *f1, *f2, *f3, *f4, *f5, *f6, *f7, *f8);
   *f1 = 100 - *f1; *f2 = 100 - *f2; *f3 = 100 - *f3; *f4 = 100 - *f4; *f5 = 100 - *f5; *f6 = 100 - *f6; *f7 = 100 - *f7; *f8 = 100 - *f8;
}

DLL_EXPORT void STDCALL input_output_char_ptr_8_parm_stdcall(char* c1, char* c2, char* c3, char* c4, char* c5, char* c6, char* c7, char* c8)
{
   flog("input_output_char_ptr_8_parm_stdcall() and input values: '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s'\n", c1, c2, c3, c4, c5, c6, c7, c8);
   strcpy(c1, "0"); strcpy(c2, "1"); strcpy(c3, "2"); strcpy(c4, "3"); strcpy(c5, "4"); strcpy(c6, "5"); strcpy(c7, "6"); strcpy(c8, "7");
}
#endif
