
#include "helper.h"

extern int64_t ivalues[];
extern int i_idx;
extern int64_t mask;
extern int i_len;
extern double dvalues[];
extern int d_idx;
extern char* text;
extern char* other;
extern int64_t num64;
extern int d_len;

#define NEXTIFUNC(typ, fname, maskval)  DLL_HIDE typ fname()\
{\
   mask = maskval;\
   int64_t num = (ivalues[i_idx++] & mask);\
\
   if (i_idx >= i_len)\
      i_idx = 0;\
\
   flog(#fname "() - returning %" PRId64 " with mask 0x%016X\n", num, mask);\
\
   CLEAR_RETURN_REGISTER\
   return num;\
}

#define NEXTDFUNC(typ, fname)  DLL_HIDE typ fname()\
{\
   typ num = dvalues[d_idx++];\
\
   if (d_idx >= d_len)\
      d_idx = 0;\
\
   flog(#fname "() - returning %g\n", num);\
\
   CLEAR_RETURN_REGISTER\
   return num;\
}

#define RETFUNC(typ, cconv, fname, gname)  DLL_EXPORT typ cconv fname() { return gname(); }

// CDECL functions
DLL_EXPORT char* CDECL return_char_ptr_cdecl() { flog("return_char_ptr_cdecl()\n"); return text; }
DLL_EXPORT void* CDECL return_void_ptr_cdecl() { flog("return_void_ptr_cdecl()\n"); return other; }
DLL_EXPORT char** CDECL return_char_ptr_ptr_cdecl() { flog("return_char_ptr_ptr_cdecl()\n"); return &text; }
DLL_EXPORT void** CDECL return_void_ptr_ptr_cdecl() { flog("return_void_ptr_ptr_cdecl()\n"); return (void**) &other; }
DLL_EXPORT int64_t* CDECL return_int64_ptr_cdecl() { flog("return_int64_ptr_cdecl()\n"); return &num64; }
DLL_EXPORT int CDECL return_multi_input(int one, int two, int three) { flog("return_multi_input()\n"); return 14; }

NEXTIFUNC(uint8_t, next_uint8_value, 0x00000000000000FFLL)
RETFUNC(uint8_t, CDECL, return_uint8_cdecl, next_uint8_value)

NEXTIFUNC(int16_t, next_int16_value, 0x000000000000FFFFLL)                
RETFUNC(int16_t, CDECL, return_int16_cdecl, next_int16_value)

NEXTIFUNC(uint16_t, next_uint16_value, 0x000000000000FFFFLL)
RETFUNC(uint16_t, CDECL, return_uint16_cdecl, next_uint16_value)

NEXTIFUNC(int32_t, next_int32_value, 0x00000000FFFFFFFFLL)
RETFUNC(int32_t, CDECL, return_int32_cdecl, next_int32_value)

NEXTIFUNC(uint32_t, next_uint32_value, 0x00000000FFFFFFFFLL)
RETFUNC(uint32_t, CDECL, return_uint32_cdecl, next_uint32_value)

NEXTIFUNC(int64_t, next_int64_value, 0xFFFFFFFFFFFFFFFFLL)
RETFUNC(int64_t, CDECL, return_int64_cdecl, next_int64_value)

NEXTDFUNC(float, next_float_value)
RETFUNC(float, CDECL, return_float_cdecl, next_float_value)

NEXTDFUNC(double, next_double_value)
RETFUNC(double, CDECL, return_double_cdecl, next_double_value)

// STDCALL functions (only emit on Windows 32-bit)
#ifdef WINDOWS32
RETFUNC(uint8_t, STDCALL, return_uint8_stdcall, next_uint8_value)
RETFUNC(int16_t, STDCALL, return_int16_stdcall, next_int16_value)
RETFUNC(uint16_t, STDCALL, return_uint16_stdcall, next_uint16_value)
RETFUNC(int32_t, STDCALL, return_int32_stdcall, next_int32_value)
RETFUNC(uint32_t, STDCALL, return_uint32_stdcall, next_uint32_value)
RETFUNC(int64_t, STDCALL, return_int64_stdcall, next_int64_value)
RETFUNC(float, STDCALL, return_float_stdcall, next_float_value)
RETFUNC(double, STDCALL, return_double_stdcall, next_double_value)

DLL_EXPORT char* STDCALL return_char_ptr_stdcall() { flog("return_char_ptr_stdcall()\n"); return text; }
DLL_EXPORT void* STDCALL return_void_ptr_stdcall() { flog("return_void_ptr_stdcall()\n"); return other; }
DLL_EXPORT char** STDCALL return_char_ptr_ptr_stdcall() { flog("return_char_ptr_ptr_stdcall()\n"); return &text; }
DLL_EXPORT void** STDCALL return_void_ptr_ptr_stdcall() { flog("return_void_ptr_ptr_stdcall()\n"); return (void**) &other; }
#endif
